<template>
  <div class="app-container">
    <crud-table
      @getList="fetchCollection"
      @go="go"
      @remove="remove"
      @selection-change="updateSelectedRows"
      :resourceName="resourceName"
      :rows="collection.data"
      :loading="loading"
    >
      <template slot="columns">
        <el-table-column
          type="selection"
          width="55">
        </el-table-column>
        <el-table-column
          prop="deliveryDate" label="F. Entrega" :min-width="20" :formatter="formatDate"
        />
        <el-table-column
          prop="updatedAt" label="Ult. Modif." :min-width="34" :formatter="formatDateTime"
        />
        <el-table-column
          prop="state" label="Estado" :min-width="20">
          <template slot-scope="scope">
            <el-tag :type="stateToTagType(scope.row.state)">{{ $t(scope.row.state) }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column
          prop="salesman.name" label="Vendedor" :min-width="50" />
        <el-table-column
          prop="client.name" label="Cliente" :min-width="50" />
      </template>

      <el-row :gutter="20" slot="filters">
        <el-col :span="6">
          <app-date-range-filter
            v-model="filters.deliveryDate"
            @input="fetchCollection"
            type="daterange"
            helpText="Rango de F. Entrega"
            start-placeholder="ent. desde"
            end-placeholder="ent. hasta"/>
        </el-col>
        <el-col :span="6">
          <el-select
            @input="fetchCollection"
            v-model="filters.state.$in"
            placeholder="Estado" multiple>
            <el-option
              v-for="(state, idx) in orderStates"
              :key="idx"
              :label="$t(state)"
              :value="state">
            </el-option>
          </el-select>
        </el-col>
        <el-col :span="6">
          <el-select
            v-model="filters.salesman.$in"
            @input="debouncedFetchCollection"
            placeholder="Vendedor" multiple>
            <el-option
              v-for="salesman in salesmen"
              :key="salesman._id"
              :label="salesman.name"
              :value="salesman._id">
            </el-option>
          </el-select>
        </el-col>
        <el-col :span="6">
          <el-select
            v-model="filters.client"
            placeholder="Cliente"
            :remote-method="filterClients"
            @input="fetchCollection"
            remote
            filterable
            clearable
          >
            <el-option
              v-for="client in filteredClients"
              :key="client._id"
              :label="client.name"
              :value="client._id" />
          </el-select>
        </el-col>
      </el-row>
      <template slot="buttons">
        <el-button class="filter-item" @click="go('create')" type="primary" icon="el-icon-circle-plus">
          Nuevo
        </el-button>
        <el-button :disabled="approveDisabled" @click="confirmOpened = true" icon="el-icon-circle-check" class="filter-item" type="success">
          Aprobar
        </el-button>
      </template>

    </crud-table>
    <el-pagination
      background
      @current-change="paginate"
      layout="total, prev, pager, next"
      :page-size="collection.limit"
      :total="collection.total">
    </el-pagination>

    <el-dialog
      title="Aprobar pedidos"
      :visible.sync="confirmOpened"
      width="30%" center>
      <el-form>
        <el-form-item label="Nuevo Estado:" :inline="true">
          <el-select v-model="stateToSwitch">
            <el-option
              v-for="(state, idx) in orderStates"
              :key="idx"
              :label="$t(state)"
              :value="state" />
          </el-select>
        </el-form-item>
      </el-form>
      <p>
        Se han seleccionado <strong>{{ ordersToApprove }}</strong> pedidos para pasar al estado <strong>{{ $t(stateToSwitch) }}</strong>. ¿Está seguro que desea continuar?
      </p>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="confirm">Sí</el-button>
        <el-button @click="confirmOpened = false">No</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
  import orderStates from '@/services/order-states'
  import { DateTime } from 'luxon'
  import api from '@/feathers'
  import CrudTable from '@/common/crud-table.component'
  import CrudTableMixin from '@/common/crud-table.mixin'
  import AppDateRangeFilter from '@/common/date-range-filter'
  import { debounce } from 'lodash'
  import { filterQuery } from '@/common/query'

  export default {
    name: 'orders-list',
    mixins: [CrudTableMixin],
    components: {
      CrudTable,
      AppDateRangeFilter
    },
    data() {
      return {
        resourceName: {
          singular: 'Order',
          plural: 'Orders'
        },
        collection: {
          data: [],
          total: 0
        },
        filters: {
          $limit: 20,
          $skip: 0,
          state: { $in: [] },
          salesman: { $in: [] },
          client: '',
          deliveryDate: this.getDefaultDeliveryDate(), // If setted on created it breaks the validation
        },
        salesmen: [],
        filteredClients: [],
        selectedRows: [],
        loading: false,
        confirmOpened: false,
        stateToSwitch: 'confirmed'
      }
    },
    computed: {
      query() {
        return filterQuery({
          $populate: ['client', 'salesman'],
          $sort: {updatedAt: -1}
        }, this.filters)
      },
      approveDisabled() {
        return this.selectedRows.length === 0
      },
      ordersToApprove() {
        return this.selectedRows.length
      }
    },
    async created() {
      this.routePrefix = 'orders'
      this.service = api.service('orders')
      this.clientsService = api.service('clients')
      this.getStates()

      await this.getSalesmen()
      await this.fetchCollection()
    },
    methods: {
      async confirm() {
        this.confirmOpened = false
        const orderIds = this.selectedRows.map(order => order._id)
        await this.service.patch(
          null,
          { state: this.stateToSwitch },
          { query: { _id: { $in: orderIds }}}
        )
        return this.fetchCollection()
      },
      updateSelectedRows(selection) {
        this.selectedRows = selection
      },
      async debouncedFetchCollection() {
        return debounce(this.fetchCollection, 500)()
      },
      async fetchCollection() {
        this.loading = true
        const response = await this.service.find({
          query: this.query
        })
        this.collection = response
        this.loading = false
      },
      async filterClients(filterName) {
        const query = {name: {$search: filterName}}
        const clients = await this.clientsService.find({query})
        this.filteredClients = clients.data
      },
      async getSalesmen() {
        this.salesmen = await api.service('salesmen').find({query: {$limit: -1}})
      },
      getDefaultDeliveryDate() {
        const today = DateTime.local()
        return {
          $gte: today.startOf('week'),
          $lt: today.plus({days: 1})
        }
      },
      getStates() {
        this.orderStates = orderStates.getStates()
        this.filters.state.$in = ['presented']
      },
      stateToTagType(state) {
        return orderStates.getColor(state)
      },
      formatDate(row, { property }) {
        const dt = DateTime.fromISO(row[property])
        return dt.toLocaleString()
      },
      formatDateTime(row, { property }) {
        const dt = DateTime.fromISO(row[property])
        return dt.toLocaleString(DateTime.DATETIME_MED)
      }
    }
  }
</script>
